﻿using System;
using System.Collections.Generic;
using System.Linq;
using SqlSugar;
namespace Ems.CollectService.Entity
{
    /// <summary>
    /// 采集设备信息
    ///</summary>
    [SugarTable("base_collect_device_info")]
    public class BaseCollectDeviceInfo
    {
        /// <summary>
        /// 自增标识 
        ///</summary>
         [SugarColumn(ColumnName="objid" ,IsPrimaryKey = true ,IsIdentity = true  )]
         public int Objid { get; set; }
        /// <summary>
        /// 设备编号 
        ///</summary>
         [SugarColumn(ColumnName="collect_device_id" ,IsPrimaryKey = true   )]
         public string CollectDeviceId { get; set; }
        /// <summary>
        /// 设备名称 
        ///</summary>
         [SugarColumn(ColumnName="collect_device_name"    )]
         public string CollectDeviceName { get; set; }
        /// <summary>
        /// 生产厂家 
        ///</summary>
         [SugarColumn(ColumnName="manufacturer"    )]
         public string Manufacturer { get; set; }
        /// <summary>
        /// 生产编号 
        ///</summary>
         [SugarColumn(ColumnName="factory_number"    )]
         public string FactoryNumber { get; set; }
        /// <summary>
        /// 生产日期 
        ///</summary>
         [SugarColumn(ColumnName="produce_date"    )]
         public DateTime? ProduceDate { get; set; }
        /// <summary>
        /// 安装位置 
        ///</summary>
         [SugarColumn(ColumnName="address"    )]
         public string Address { get; set; }
        /// <summary>
        /// 能源类型 
        ///</summary>
         [SugarColumn(ColumnName="energy_type"    )]
         public int? EnergyType { get; set; }
        /// <summary>
        /// 型号 
        ///</summary>
         [SugarColumn(ColumnName="model"    )]
         public string Model { get; set; }
        /// <summary>
        /// 地址 
        ///</summary>
         [SugarColumn(ColumnName="ip"    )]
         public string Ip { get; set; }
        /// <summary>
        /// 备注 
        ///</summary>
         [SugarColumn(ColumnName="remark"    )]
         public string Remark { get; set; }
        /// <summary>
        /// 终端在线状态 
        ///</summary>
         [SugarColumn(ColumnName="online_state"    )]
         public int? OnlineState { get; set; }
        /// <summary>
        /// 权限标识（部门） 
        ///</summary>
         [SugarColumn(ColumnName="dept_id"    )]
         public int? DeptId { get; set; }
        /// <summary>
        /// 权限标识（用户） 
        ///</summary>
         [SugarColumn(ColumnName="user_id"    )]
         public int? UserId { get; set; }
        /// <summary>
        /// 创建人 
        ///</summary>
         [SugarColumn(ColumnName="create_by"    )]
         public string CreateBy { get; set; }
        /// <summary>
        /// 创建时间 
        ///</summary>
         [SugarColumn(ColumnName="create_time"    )]
         public DateTime? CreateTime { get; set; }
        /// <summary>
        /// 更新人 
        ///</summary>
         [SugarColumn(ColumnName="update_by"    )]
         public string UpdateBy { get; set; }
        /// <summary>
        /// 更新时间 
        ///</summary>
         [SugarColumn(ColumnName="update_time"    )]
         public DateTime? UpdateTime { get; set; }
    }
}
